import java.awt.*;





public class BorderPanel extends Panel {

Image offImage=null;
Dimension offDimension=null;
Graphics offGraphics=null; 

    public final static int PLAIN    = 0;
    public final static int BOLD     = 1;
    public final static int ITALIC   = 2;

    public final static int ENGRAVED = 0;
    public final static int EMBOSSED = 1;
    public final static int RAISED   = 2;
    public final static int EMBEDED  = 3;
    public final static int STANDARD = 4;

	FontMetrics fm;

    protected int style;
    protected int size;

    protected int bstyle;
    protected int bsize;
    protected String name;

    protected String label;
    private static Font theFont;
	Image theimage=null;
	boolean tiled=false;

    BorderPanel(int bpstyle, int bpsize, String name, int style, int size, Image image) {
        super();
        //this.bstyle = bpstyle;
        //this.bsize = bpsize;
        this.bstyle = 3;
        this.bsize = 2;
	theimage = image;

        this.name = name;
        this.style = style;
        this.size = size;
        theFont = new Font(name, style, size);
    }
    BorderPanel(int bpstyle, int bpsize, String name, int style, int size, Image image, boolean tiled) {
        super();
        //this.bstyle = bpstyle;
        //this.bsize = bpsize;
        this.bstyle = 3;
        this.bsize = 2;
	theimage = image;
	this.tiled = tiled;

        this.name = name;
        this.style = style;
        this.size = size;
        theFont = new Font(name, style, size);
    }

    BorderPanel(int bpstyle, int bpsize, String name, int style, int size) {
        super();
        //this.bstyle = bpstyle;
        //this.bsize = bpsize;
        this.bstyle = 3;
        this.bsize = 2;

        this.name = name;
        this.style = style;
        this.size = size;
        theFont = new Font(name, style, size);
    }


    public void setLabel(String label){
        this.label = label;

        if (theFont == null){
            theFont = new Font("Dialog",Font.PLAIN,10);
        }

        fm = getFontMetrics(theFont);
	Rectangle r = this.getBounds();
	int width = r.width; 
        int height = fm.getHeight();
	int x = (r.x/2) - (width/2);
	int y = (r.y/2) - (height/2);

        Label title;

        if (this.label.length() > 1) {
            title = new Label(label, java.awt.Label.CENTER);
            title.setFont(new Font(theFont.getName(), theFont.getStyle(), theFont.getSize()));
            this.add(title);
	    title.setBounds(x,y,width,height);
        }
    }

    public void setImage(Image i, boolean tiled) {
	theimage = i;
	this.tiled = tiled;
    }

    public String getLabel(){
        return label;
    }

    public int getBorderStyle() {
        return bstyle;
    }

    public int getBorderSize() {
        return bsize;
    }


	public void paint(Graphics g) {
		update(g);
	}


    public void update(Graphics g) {
        Dimension d = this.getSize();

        if ( (offGraphics == null) || (d.width != offDimension.width) || (d.height != offDimension.height) ) {
            offDimension = d;
            offImage = createImage(d.width, d.height);
            offGraphics = offImage.getGraphics();
	}

	offGraphics.setColor(getBackground());
	offGraphics.fillRect(0, 0, d.width, d.height);
	//offGraphics.setColor(Color.black);

	int p_width;
	int p_height;
	Dimension of_panel;
	int i;

	of_panel = this.getSize();
	Insets insets = this.getInsets();
	p_width  = of_panel.width - (insets.left+insets.right);
	p_height = of_panel.height - (insets.top+insets.bottom);

	p_width-=6;
	p_height-=6;

	int y = insets.top+3; 

	if(theimage!=null && !tiled) offGraphics.drawImage(theimage,insets.left+4,insets.top+4,p_width-8,p_height-8,this);

	if(theimage!=null && tiled) {

		double iwidth = new Double(theimage.getWidth(this)).doubleValue();	
		double iheight = new Double(theimage.getHeight(this)).doubleValue();	

		double bwidth = new Double((p_width-8) - (insets.left+4)).doubleValue(); 
		double bheight = new Double((p_height-8) - (insets.top+4)).doubleValue(); 
		double rows=1, cols=1;

		rows = new Double(bheight/iheight).doubleValue(); 
		cols = new Double(bwidth/iwidth).doubleValue();

		if(rows<0) rows=1;
		if(cols<0) cols=1;

		for(int cnt1=0; cnt1<rows; cnt1++) {
			double adjwidth = bwidth/cols;
			double adjheight = bheight/rows;

			for(int cnt2=0; cnt2<cols; cnt2++) {
				int xx = new Double((insets.left+4)+cnt2*adjwidth).intValue();
				int yy = new Double((insets.top+4)+cnt1*adjheight).intValue();

				int thiswidth = new Double(adjwidth).intValue();
				int thisheight = new Double(adjheight).intValue();

				if((xx+adjwidth) > p_width) thiswidth=p_width-xx;
				if((yy+adjheight) > p_height) thisheight=p_height-yy;

				offGraphics.drawImage(theimage, xx, yy, thiswidth, thisheight, this);
			}
		}	
		
	}

	if (bstyle == 0) {
	    offGraphics.setColor(Color.white);
	    offGraphics.drawRect(insets.left,y+1,p_width,(p_height-y)-1);
	    offGraphics.setColor(Color.darkGray);
	    offGraphics.drawRect(insets.left+1,y,p_width-1,p_height-y);
	}
	if (bstyle == 1) {
	    offGraphics.setColor(Color.darkGray);
	    offGraphics.drawRect(insets.left+1,y+1,p_width-1,(p_height-y)-1);
	    offGraphics.setColor(Color.white);
	    offGraphics.drawRect(insets.left,y,p_width,p_height-y);
	}
	if (bstyle == 2) {
	    for (i=0;i<=bsize;i++) {
		Color c = new Color(0xE0E0E0);

		offGraphics.setColor(c.brighter());
		offGraphics.drawLine(i, y, i, (insets.top + p_height)-i);
		offGraphics.drawLine(1-i, y+i, (insets.left + p_width - 1)-i, y+i);
		offGraphics.setColor(c.darker());
		offGraphics.drawLine(i, p_height-i, p_width-i, p_height-i);
		offGraphics.drawLine(p_width-i, y+i, p_width-i, (p_height-1)-i);
	    }
	}
	if (bstyle == 3) {
	    for (i=0;i<=bsize;i++) {
		Color c = new Color(0xE0E0E0);

		offGraphics.setColor(c.darker());
		offGraphics.drawLine(i, y, i, (insets.top + p_height)-i);
		offGraphics.drawLine(1-i, y+i, (insets.left + p_width - 1)-i, y+i);
		offGraphics.setColor(c.brighter());
		offGraphics.drawLine(i, p_height-i, p_width-i, p_height-i);
		offGraphics.drawLine(p_width-i, y+i, p_width-i, (p_height-1)-i);
	    }
	}
	if (bstyle == 4) {
	}
	
	g.drawImage(offImage, 0, 0, this);
    }
}
