import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class CalendarPanel extends Panel implements java.awt.event.ItemListener , java.awt.event.ActionListener, java.awt.event.KeyListener {

	Choice month;
	TextField aar;
	SpinControl hspin;
	static final int rows = 6;
	static final int cols = 7;
	int DaysInMonth[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	Date currentdate, datetest;
	Button button;
	TextField text1;
	String day;
	String mon;
	String year;
	String thedate;
	boolean calpanelflag = false;
	boolean attachtotop=true;
	boolean refreshparent=false;
	Container parentcontainer=null;

	int curday[];
	

	private ActionListener actionListener=null;


	public Dimension getPreferredSize() {
		return this.getSize(); 
	}
	public Dimension getMinimumSize() {
		return this.getSize(); 
	}

	public void setAttachToTop(boolean state) {
		attachtotop=state;
	}
	public void setRefreshParent(boolean state, java.awt.Container container) {
		refreshparent=state;
		parentcontainer=container;	
	}

	public void setDateString(String ndate) {
		StringTokenizer st = new StringTokenizer(ndate,"/");
		if(st.countTokens()<3) return;
		String mon=st.nextToken();
		String day=st.nextToken();
		String year=st.nextToken();
		this.setDate(  new Date(new Integer(year).intValue()-1900, new Integer(mon).intValue()-1, new Integer(day).intValue()));
	}
	public String getDateString() {
		String mon = new Integer(currentdate.getMonth()+1).toString();
		String day = new Integer(currentdate.getDate()).toString();
		String year = new Integer(currentdate.getYear()+1900).toString();
		if(mon.length()==1) mon="0".concat(mon);
		if(day.length()==1) day="0".concat(day);

		return mon+"/"+day+"/"+year; 
	}
	
	public CalendarPanel(String label) {

		setLayout(null);
		currentdate = new Date(); 

		this.setSize(185,20);

		text1 = new TextField(8);
		text1.setEditable(false);
		this.add(text1);
		text1.setBounds(new Rectangle(0,0,90,20));

		button = new Button(label+" v");
		button.addActionListener(this);
		this.add(button);
		button.setBounds(new Rectangle(95,0,90,20));


		month = new Choice();
		month.addItem("January");
		month.addItem("February");
		month.addItem("March");
		month.addItem("April");
		month.addItem("May");
		month.addItem("June");
		month.addItem("July");
		month.addItem("August");
		month.addItem("September");
		month.addItem("October");
		month.addItem("November");
		month.addItem("December");
		month.addItemListener(this);
		month.select(currentdate.getMonth());

		month.setBounds(new Rectangle(0,20,90,20));
		this.add(month);
		
		hspin = new SpinControl(60,20,currentdate.getYear()+1900);
		hspin.addActionListener(this);
		hspin.spintext.addKeyListener(this);
		this.add(hspin);
		hspin.setBounds(new Rectangle(90,20,90,20));

		curday = new int[54];
		setFont(new Font("Monospaced", 1, 10));
		setBackground(Color.lightGray);
		drawCalendar(currentdate);

	}

	public void updateTextBox() {
		text1.setText(this.getDateString());
	}

	public Date getDate() {
		return currentdate;
	}


	public void setDate(Date date) {
		currentdate = date;	
		month.select(date.getMonth());
		hspin.setText(new Integer(date.getYear()+1900).toString());
		drawCalendar(currentdate);
	}


	public void addActionListener(ActionListener listener) {
		actionListener = AWTEventMulticaster.add(actionListener, listener);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

	public void removeActionListener(ActionListener listener) {
		actionListener = AWTEventMulticaster.remove(actionListener, listener);
	}

	public void processMouseEvent(MouseEvent e) {

		if(e.getID() == MouseEvent.MOUSE_RELEASED) {

			int mousex=e.getX();
			int mousey=e.getY();
			int x = 0; 
			int y = 15; 
			boolean datechangedflag=false;
			
		    	if (mousex > 6+x && mousex <174+x && mousey>35+y && mousey<172+y) {
				int k = 0;
				for(int j = 0; j <= 6; ++j) {
					for(int i = 1; i <= 7; ++i) {
						if (curday[k]>0) {
							if (mousex>i*24-18+x && mousex<i*24+5+x && mousey>y+35+j*20 && mousey<y+54+j*20) {
								datetest = new Date(new Integer(hspin.getText()).intValue()-1900, month.getSelectedIndex(), curday[k]);
								drawCalendar(datetest);
								datechangedflag=true;
							}
						}
						k++;
					}
				}
			}
			if(actionListener != null && datechangedflag) {
				currentdate=datetest;
				updateTextBox();
				actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "" +this));
			}

		}


		super.processMouseEvent(e);

	}

	public void dropit(boolean state) {
		if(state) { 
			calpanelflag = true; 
			this.setSize(185,195);
		}
		else {
			calpanelflag = false; 
			this.setSize(185,20);
		}
		repaint();
	}

public void keyPressed(java.awt.event.KeyEvent e) {
	if(e.getSource()==hspin.spintext) {
		if(e.getKeyCode()==java.awt.event.KeyEvent.VK_ENTER) { 
			if(hspin.getText().length()!=4) {
				hspin.setText(new Integer(currentdate.getYear()+1900).toString());
			}
			int y = new Integer(hspin.getText()).intValue()-1900;
			int m = month.getSelectedIndex();
			if(m==-1) m=0;
			int d = currentdate.getDate();
			
			currentdate = new Date(y, m, d);
			drawCalendar(currentdate);
		}
	}
}
public void keyReleased(java.awt.event.KeyEvent e) {
}
public void keyTyped(java.awt.event.KeyEvent e) {
}

public void actionPerformed(java.awt.event.ActionEvent e) {
		if (e.getSource() == hspin) {
			if(hspin.getText().length()!=4) {
				hspin.setText(new Integer(currentdate.getYear()+1900).toString());
			}

			int y = Integer.parseInt(hspin.getText())-1900;
			int m = month.getSelectedIndex();
			int d = currentdate.getDate();
			
			currentdate = new Date(y, m, d);
			drawCalendar(currentdate);
		}

		if (e.getSource() == button) {
			calpanelflag = !calpanelflag;
			Rectangle r = this.getBounds();

			if(attachtotop) {
				if(calpanelflag) this.setBounds(r.x,5,185,195);
					else this.setBounds(r.x,r.y,185,20);
			}
			else {
				if(calpanelflag) this.setSize(185,195);
					else this.setSize(185,20);
			}
			repaint();

			if(refreshparent) {
				parentcontainer.invalidate();
				parentcontainer.validate();
			}
		}
}


public void itemStateChanged(java.awt.event.ItemEvent e) {

	if (e.getSource() == month) {
		int y = new Integer(hspin.getText()).intValue()-1900;
		int m = month.getSelectedIndex();
		int d = currentdate.getDate();
		currentdate = new Date(y, m, d);
		drawCalendar(currentdate);
	}
}



	public void paint(Graphics g) {
	if(calpanelflag) {	

		int width  = 180; 
		int height = 180; 
		int x = 3; 
		int y = 15; 

		g.setColor(Color.lightGray);
		g.draw3DRect(1+x,y+1,width-3,height-3,true);  
		
		int k = 0;
		for(int j = 0; j <= 6; ++j)
		{
		    for(int i = 1; i <= 7; ++i)
		    {
			if (curday[k]>0) {
			    if (curday[k]==currentdate.getDate()) {
				g.setColor(new Color(170,170,250));
				g.fillRect(x+(i*24-18),y+(35+j*20),23,19);
			    }
			    else {
				g.setColor(Color.lightGray);
				g.draw3DRect(x+(i*24-18),y+(35+j*20),23,19,true);
			    }
			    g.setColor(Color.black);
			    if (curday[k]>9) g.drawString(String.valueOf(curday[k]),x+(i*24-11),y+(49+j*20));
			    else g.drawString(" "+String.valueOf(curday[k]),x+(i*24-11),y+(49+j*20));
			    g.setColor(Color.lightGray);
			}
			k++;
		    }
		}

		g.setColor(new Color(170,170,200));
		g.fillRect(x+10,y+40,x+14+24*6,13);
		g.setColor(Color.black);
		
		g.drawString("M",x+13,y+50);
		g.drawString("T",x+15+25,y+50);
		g.drawString("W",x+14+24*2,y+50);
		g.drawString("T",x+14+24*3,y+50);
		g.drawString("F",x+14+24*4,y+50);
		g.drawString("S",x+14+24*5,y+50);
		g.drawString("S",x+14+24*6,y+50);

		Date todaydate = new Date();
		String mon = new Integer(todaydate.getMonth()+1).toString();
		String day = new Integer(todaydate.getDate()).toString();
		String year = new Integer(todaydate.getYear()+1900).toString();
		if(mon.length()==1) mon="0".concat(mon);
		if(day.length()==1) day="0".concat(day);

		g.setColor(new Color(170,170,200));
		g.fillRect(x+57,y+160,119,13);
		g.setColor(Color.black);
		g.drawString("Today: "+mon+"/"+day+"/"+year,x+57,y+170);
	 }
	}

	
	public void drawCalendar(Date now) {
		updateTextBox();

		int iMonth = now.getMonth(); 
		int iYear = now.getYear(); 
		int iDays = 29;

		Date cc = new Date(iYear, iMonth, 1); 

		int dayofweek =  cc.getDay()+5;
		if (dayofweek==0+5) dayofweek=7+5;

		if (iMonth == 1) {
			if (isLeapyear(iYear+1900))
				iDays = 30;
		}
		else
			iDays = DaysInMonth[iMonth]+1;

		for (int i = 0; i < 54; i++) {
			curday[i]=0;
		}

		for (int i = dayofweek; i < iDays+dayofweek; i++) {
			curday[i]=i-(dayofweek);
		}

		repaint();
	}

	public boolean isLeapyear(int year) {
		if ((year % 100) == 0) return((year % 400) == 0);
		return ((year % 4) == 0);
	}


}



class SpinControl extends Panel {

    public TextField spintext;
    int minx,miny;
    boolean up1 = true;
    boolean up2 = true;
    ActionListener actionListener=null;
    
    SpinControl() {
        setLayout(null);
        spintext = new TextField("0");
        spintext.setBounds(new Rectangle(0,0,40,20));
        add(spintext);
        minx = 55;
        miny = 20;
    }

    SpinControl(int w, int h, int val) {
        setLayout(null);
        spintext = new TextField(new Integer(val).toString());
        spintext.setBounds(new Rectangle(0,0,70,20));
        add(spintext);
        minx = w;
        miny = h;
    }

    public void setText(String st) {
        spintext.setText(st);
    }
    public String getText() {
        return spintext.getText();
    }

	public Dimension getPreferredSize() {
		return new Dimension(90,20); 
	}
	public Dimension getMinimumSize() {
		return new Dimension(90,20); 
	}

	public void addActionListener(ActionListener listener) {
		actionListener = AWTEventMulticaster.add(actionListener, listener);
		enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

	public void removeActionListener(ActionListener listener) {
		actionListener = AWTEventMulticaster.remove(actionListener, listener);
	}

	public void processMouseEvent(MouseEvent e) {
		int x = e.getX();
		int y = e.getY();

		if(e.getID() == MouseEvent.MOUSE_RELEASED) {
			if (x>70 && y<10) {
			    up1 = true;
			    up2 = true;
				if(spintext.getText().length()<4) {
					spintext.setText("1998");
				}
			    spintext.setText(String.valueOf(Integer.parseInt(spintext.getText())+1));
			    
			}
			else if (x>70 && y>10) {
			    up1 = true;
			    up2 = true;
				if(spintext.getText().length()<4) {
					spintext.setText("1998");
				}
			    spintext.setText(String.valueOf(Integer.parseInt(spintext.getText())-1));
			    
			}
			if(actionListener != null) {
				actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "" +this));
			}
		}
		if(e.getID() == MouseEvent.MOUSE_RELEASED) {
			if (x>70 && y<10) {
			    up1 = false;
			    up2 = true;
			}
			else if (x>70 && y>10) {
			    up1 = true;
			    up2 = false;
			}
			if(actionListener != null) {
				actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, "" +this));
			}
		}


		super.processMouseEvent(e);
	}
                                
    public void paint(Graphics g)
    {
        Dimension s;
        int width = 90;
        int height = 20;

        g.setColor(Color.lightGray);
        g.fill3DRect(width-15,0,15,height/2,true);
        g.fill3DRect(width-15,height/2,15,height/2,true);
        g.setColor(Color.black);

        Polygon p1 = new Polygon();
        p1.addPoint(width-8,height/4-3);
        p1.addPoint(width-3,height/4+3);
        p1.addPoint(width-13,height/4+3);
        g.fillPolygon(p1);
        Polygon p2 = new Polygon();
        p2.addPoint(width-8,(3*height)/4+2);
        p2.addPoint(width-4,(3*height)/4-3);
        p2.addPoint(width-12,(3*height)/4-3);
        g.fillPolygon(p2);
        
    }


    
}
