import java.awt.*;
import java.awt.event.*;

public class ConsoleDialog extends Dialog implements WindowListener
{

    private Toolkit tk=null;
    private TextArea TextArea1 = null;

    public ConsoleDialog( Frame parentFrame )
    {

        super( parentFrame, "Console", false );

        setBackground( new Color( 192, 192, 192 ) );
        setForeground( new Color( 0, 0, 0 ) );

	tk = parentFrame.getToolkit(); 
	Dimension screensize = tk.getScreenSize();
	int adjwidth = 500; 
	int adjheight = 300; 
	this.setBounds(new Rectangle((screensize.width-adjwidth)/2, (screensize.height-adjheight)/2, adjwidth, adjheight));

        setResizable( false );

        addWindowListener( this );

        makeGUI();
        TextArea1.setEditable( false );

    }



/******************************************************/
	public TextArea getConsole() {
		return TextArea1;
	}

/*****************************************************/

    private void makeGUI()
    {

        LavaLayout mainLayout = new LavaLayout( 15, 15 );
        setLayout( mainLayout );
        TextArea1 = new TextArea( "", 10, 10 );
        mainLayout.setConstraints( TextArea1, makeLavaCons( 0, 0, 15, 15 ) );
        add( TextArea1 );
        TextArea1.setBackground( new Color( 192, 192, 192 ) );
        TextArea1.setForeground( new Color( 0, 0, 0 ) );
        TextArea1.setEnabled( true );
        TextArea1.setVisible( true );

    }

    public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
    {

        GridBagConstraints cons = new GridBagConstraints();

        cons.weightx    = wx;
        cons.weighty    = wy;
        cons.gridx      = x;
        cons.gridy      = y;
        cons.gridwidth  = dx;
        cons.gridheight = dy;
        cons.fill       = fill;
        cons.anchor     = anch;
        cons.insets     = new Insets( it, il, ib, ir );
        cons.ipadx      = px;
        cons.ipady      = py;

        return cons;

    }

    public LavaLayoutConstraints makeLavaCons( int x, int y, int dx, int dy )
    {

        LavaLayoutConstraints cons = new LavaLayoutConstraints();

        cons.gridX      = x;
        cons.gridY      = y;
        cons.gridWidth  = dx;
        cons.gridHeight = dy;

        return cons;

    }

    public void windowClosing( WindowEvent event ) { dispose(); }
    public void windowOpened( WindowEvent event ) {}
    public void windowIconified( WindowEvent event ) {}
    public void windowDeiconified( WindowEvent event ) {}
    public void windowClosed( WindowEvent event ) {}
    public void windowActivated( WindowEvent event ) {}
    public void windowDeactivated( WindowEvent event ) {}

}
