import java.awt.*;
import java.awt.event.*;

public class JbrowsePanel extends BorderPanel {

    public TextArea TextArea = null;
    public Button buttonDOWN = null;
    public Button buttonOpen = null;
    public Button buttonExit = null;
    public Button buttonTop = null;
    public Button buttonBottom = null;
    public Button buttonAdd = null;
    public Button buttonGoto = null;
    public Button buttonConfig = null;
    public Button buttonPack = null;
    public Button buttonUP = null;
    public TextField fieldInput = null;
    public Button buttonCreateIndex = null;
    public Button buttonFind = null;
	public Button Help=null;

    public JbrowsePanel() {

	super(BorderPanel.ENGRAVED,3,"Monospaced",BorderPanel.PLAIN,10);

	Class tc = this.getClass();
	Image bgimage = Toolkit.getDefaultToolkit().getImage(tc.getResource("default_bg.gif"));
	MediaTracker tracker = new MediaTracker(this);
	    tracker.addImage(bgimage, 0);
	try {
	    tracker.waitForAll();
	} catch (Exception e) { System.out.println(e.toString()+"<-loading bg image"); }

	this.setImage(bgimage, true);

        setBackground( new Color( 192, 192, 192 ) );
        setForeground( new Color( 0, 0, 0 ) );

        makeGUI();

    }

    private void makeGUI()
    {

        LavaLayout mainLayout = new LavaLayout( 45, 48 );
        setLayout( mainLayout );
        TextArea = new TextArea( "", 25, 80 );
        mainLayout.setConstraints( TextArea, makeLavaCons( 1, 1, 43, 38 ) );
        add( TextArea );
        TextArea.setBackground( new Color( 192, 192, 192 ) );
        TextArea.setForeground( new Color( 0, 0, 0 ) );
        TextArea.setEnabled( true );
        TextArea.setVisible( true );
        buttonDOWN = new Button( "DOWN" );
	buttonDOWN.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonDOWN, makeLavaCons( 1, 44, 4, 2 ) );
        add( buttonDOWN );
        buttonDOWN.setBackground( new Color( 192, 192, 192 ) );
        buttonDOWN.setForeground( new Color( 0, 0, 0 ) );
        buttonDOWN.setEnabled( true );
        buttonDOWN.setVisible( true );
        buttonOpen = new Button( "OPEN" );
	buttonOpen.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonOpen, makeLavaCons( 11, 40, 4, 2 ) );
        add( buttonOpen );
        buttonOpen.setBackground( new Color( 192, 192, 192 ) );
        buttonOpen.setForeground( new Color( 0, 0, 0 ) );
        buttonOpen.setEnabled( true );
        buttonOpen.setVisible( true );
        buttonExit = new Button( "EXIT" );
	buttonExit.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonExit, makeLavaCons( 21, 44, 4, 2 ) );
        add( buttonExit );
        buttonExit.setBackground( new Color( 192, 192, 192 ) );
        buttonExit.setForeground( new Color( 0, 0, 0 ) );
        buttonExit.setEnabled( true );
        buttonExit.setVisible( true );
        buttonTop = new Button( "TOP" );
	buttonTop.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonTop, makeLavaCons( 6, 40, 4, 2 ) );
        add( buttonTop );
        buttonTop.setBackground( new Color( 192, 192, 192 ) );
        buttonTop.setForeground( new Color( 0, 0, 0 ) );
        buttonTop.setEnabled( true );
        buttonTop.setVisible( true );
        buttonBottom = new Button( "BOTT" );
	buttonBottom.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonBottom, makeLavaCons( 6, 44, 4, 2 ) );
        add( buttonBottom );
        buttonBottom.setBackground( new Color( 192, 192, 192 ) );
        buttonBottom.setForeground( new Color( 0, 0, 0 ) );
        buttonBottom.setEnabled( true );
        buttonBottom.setVisible( true );
        buttonAdd = new Button( "ADD" );
	buttonAdd.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonAdd, makeLavaCons( 16, 40, 4, 2 ) );
        add( buttonAdd );
        buttonAdd.setBackground( new Color( 192, 192, 192 ) );
        buttonAdd.setForeground( new Color( 0, 0, 0 ) );
        buttonAdd.setEnabled( true );
        buttonAdd.setVisible( true );
        buttonGoto = new Button( "GOTO" );
	buttonGoto.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonGoto, makeLavaCons( 31, 40, 4, 2 ) );
        add( buttonGoto );
        buttonGoto.setBackground( new Color( 192, 192, 192 ) );
        buttonGoto.setForeground( new Color( 0, 0, 0 ) );
        buttonGoto.setEnabled( true );
        buttonGoto.setVisible( true );
        buttonConfig = new Button( "CONFIG" );
	buttonConfig.setEnabled(false);
	buttonConfig.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonConfig, makeLavaCons( 11, 44, 4, 2 ) );
        add( buttonConfig );
        buttonConfig.setBackground( new Color( 192, 192, 192 ) );
        buttonConfig.setForeground( new Color( 0, 0, 0 ) );
        buttonConfig.setVisible( true );
        buttonPack = new Button( "PACK" );
	buttonPack.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonPack, makeLavaCons( 16, 44, 4, 2 ) );
        add( buttonPack );
        buttonPack.setBackground( new Color( 192, 192, 192 ) );
        buttonPack.setForeground( new Color( 0, 0, 0 ) );
        buttonPack.setEnabled( true );
        buttonPack.setVisible( true );
        buttonUP = new Button( "UP" );
	buttonUP.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonUP, makeLavaCons( 1, 40, 4, 2 ) );
        add( buttonUP );
        buttonUP.setBackground( new Color( 192, 192, 192 ) );
        buttonUP.setForeground( new Color( 0, 0, 0 ) );
        buttonUP.setEnabled( true );
        buttonUP.setVisible( true );
        fieldInput = new TextField( "", 20 );
        mainLayout.setConstraints( fieldInput, makeLavaCons( 26, 44, 16, 2 ) );
        add( fieldInput );
        fieldInput.setBackground( new Color( 192, 192, 192 ) );
        fieldInput.setForeground( new Color( 0, 0, 0 ) );
        fieldInput.setEnabled( true );
        fieldInput.setVisible( true );
        buttonCreateIndex = new Button( "CR INDEX" );
	buttonCreateIndex.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonCreateIndex, makeLavaCons( 36, 40, 7, 2 ) );
        add( buttonCreateIndex );
        buttonCreateIndex.setBackground( new Color( 192, 192, 192 ) );
        buttonCreateIndex.setForeground( new Color( 0, 0, 0 ) );
        buttonCreateIndex.setEnabled( true );
        buttonCreateIndex.setVisible( true );
        buttonFind = new Button( "FIND" );
	buttonFind.setFont(new Font("Monospaced", 1, 12));
        mainLayout.setConstraints( buttonFind, makeLavaCons( 26, 40, 4, 2 ) );
        add( buttonFind );
        buttonFind.setBackground( new Color( 192, 192, 192 ) );
        buttonFind.setForeground( new Color( 0, 0, 0 ) );
        buttonFind.setEnabled( true );
        buttonFind.setVisible( true );

	Help = new Button("Help");
	Help.setFont(new Font("Monospaced", 1, 12));
        Help.setEnabled( true );
        Help.setVisible( true );
        mainLayout.setConstraints( Help, makeLavaCons( 43, 45, 2, 2 ) );
	add(Help);

    }

    public GridBagConstraints makeGridCons( int x, int y, int dx, int dy, int wx, int wy, int fill, int anch, int it, int il, int ib, int ir, int px, int py )
    {

        GridBagConstraints cons = new GridBagConstraints();

        cons.weightx    = wx;
        cons.weighty    = wy;
        cons.gridx      = x;
        cons.gridy      = y;
        cons.gridwidth  = dx;
        cons.gridheight = dy;
        cons.fill       = fill;
        cons.anchor     = anch;
        cons.insets     = new Insets( it, il, ib, ir );
        cons.ipadx      = px;
        cons.ipady      = py;

        return cons;

    }

    public LavaLayoutConstraints makeLavaCons( int x, int y, int dx, int dy )
    {

        LavaLayoutConstraints cons = new LavaLayoutConstraints();

        cons.gridX      = x;
        cons.gridY      = y;
        cons.gridWidth  = dx;
        cons.gridHeight = dy;

        return cons;

    }

}
